# FCaster

FCaster is a Go [library](https://pkg.go.dev/git.massive.box/massivebox/fcaster/fcast) implementing a [FCast](https://fcast.org) Sender, which allows to send media to a Receiver. It also has a simple cross-platform application, built with [Fyne](https://fyne.io), to showcase its features.

**Notice**: FCaster is NOT associated to, or endorsed by, FUTO. It's an unofficial implementation of the FCast Protocol.

## Library

The [FCast library](https://pkg.go.dev/git.massive.box/massivebox/fcaster/fcast) allows you to stream media to a FCast Receiver from your own software!  

| Feature           | Supported |
|-------------------|-----------|
| TCP               | ✅         |
| WebSockets        | ❌         |
| mDNS Discovery    | ✅         |
| Outgoing Commands | ✅         |
| Incoming Commands | ✅         |
| QR Code           | ❌         |

Since the library is in active development, its stability is not guaranteed.

## App

Due to the limitations of Fyne on Android (not implementing [foreground services](https://developer.android.com/guide/components/foreground-services)), the FCaster App will not support features such as local media casting in the near future. We are working on an alternative implementation.

Currently, the app only allows you to stream from URLs. (You can already stream Jellyfin media by copying the stream URL from Jellyfin and pasting it in the app - [detailed instructions](https://s.massive.box/fcaster-jellyfin)).

### Screenshots

| ![Main view](assets/mainView.png) | ![Cast view](assets/castView.png) |
| - | - |

### Download

Head over to the [Releases](https://git.massive.box/massivebox/fcaster/releases) page to find builds for your device. You can use [Obtanium](https://obtainium.imranr.dev/) to get automatic updates on Android.

## License

Both the FCast Library and application are (c) MassiveBox 2025 and distributed under the MIT license. Read the LICENSE file to learn more.