package fcast

type Message interface {
	getOpCode() OpCode
}

func (m PlayMessage) getOpCode() OpCode {
	return Play
}
func (m SeekMessage) getOpCode() OpCode {
	return Seek
}
func (m PlaybackUpdateMessage) getOpCode() OpCode {
	return PlaybackUpdate
}
func (m SetVolumeMessage) getOpCode() OpCode {
	return SetVolume
}
func (m VolumeUpdateMessage) getOpCode() OpCode {
	return VolumeUpdate
}
func (m PlaybackErrorMessage) getOpCode() OpCode {
	return PlaybackError
}
func (m VersionMessage) getOpCode() OpCode {
	return Version
}
func (m SetSpeedMessage) getOpCode() OpCode {
	return SetSpeed
}

// body-less
func (m PauseMessage) getOpCode() OpCode {
	return Pause
}
func (m ResumeMessage) getOpCode() OpCode {
	return Resume
}
func (m StopMessage) getOpCode() OpCode {
	return Stop
}
func (m PingMessage) getOpCode() OpCode {
	return Ping
}
func (m PongMessage) getOpCode() OpCode {
	return Pong
}
